# Svelte Component

## Content

This page provides a detailed overview of the ActiveReportsJS Svelte Report Designer. You can check the corresponding [Getting Started](/activereportsjs/docs/v6.0/GettingStarted/QuickStart-ARJS-Designer-Component/svelte) tutorial for a concise guide for integrating the designer component into a Svelte application.

### ActiveReportsJS Svelte NPM package

We provide the library that contains the ActiveReportsJS Svelte Report Designer component via the [@mescius/activereportsjs-react](https://www.npmjs.com/package/@mescius/activereportsjs-react) npm package, which depends on the main [@mescius/activereportsjs](https://www.npmjs.com/package/@mescius/activereportsjs) package that contains the core functionality.

### ActiveReportsJS Svelte Designer component

You can import the ActiveReportsJS Svelte Designer component into a Svelte component in your application and include it in the markdown, for example:

```javascript
<script lang="ts">
    import {Designer} from "@mescius/activereportsjs-svelte";
</script>

<div id="designer-host">
    <Designer report={{ id: "report.rdlx-json", displayName: "my report" }}></Designer>
</div>
```

The designer component accepts the following properties.

| Property | Type | Description |
| -------- | ---- | ----------- |
| onInit | ()=>[DesignerConfig](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#designerconfig) | returns the [DesignerConfig](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#designerconfig) that contains the designer's initialization options |
| dataSources | array of [Data Source Templates](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#datasourcetemplate) | sets the [Pre-defined data sources and data sets](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Add-Predefined-Datasources-Datasets). |
| reportList | array of [Report Resource Info items](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#reportresourceinfo) | sets the [Pre-defined report names for a subreport](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Use-Shared-Resources) |
| imageList | array of [Image Resource Info items](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#imageresourceinfo) | sets the [Pre-defined images for an Image report item](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Use-Shared-Resources) |
| onCreate | [onCreate function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#oncreate) | adds the [New Report button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Create-New-Report#enabling-the-new-report-button) in the designer toolbar and sets the corresponding click handler |
| onOpen | [onOpen function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onopen) | adds the [Open Report](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Create-New-Report#enabling-the-open-report-button) button in the designer toolbar and sets the corresponding click handler |
| onRender | [onRender function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onrender) | adds the [Preview Report button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Preview-Reports) in the designer toolbar and sets the corresponding click handler |
| onSave | [onSave function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onsave) | adds the [Save Report button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Save-Reports) in the designer toolbar and sets the corresponding click handler |
| onSaveAs | [onSaveAs function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onsaveas) | adds the [Save As.. button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Save-Reports) in the designer toolbar and sets the corresponding click handler |
| onOpenFileMenu | [onOpenFileMenu function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onopenfilemenu) | adds the "File" menu in the designer toolbar and sets the corresponding click handler |
| report | [report object](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#report) | loads the specified report in the designer |
| documentChanged | (args: [DocumentChangedEventArgs](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#documentchangedeventargs))=>void | sets the handler for the event that occurs when a report loaded into the designer changes |

Also, you can access the `createReport`, `getReport`, `setReport`, and `processCommand` methods of the [Designer class instance](https://developer.mescius.com/activereportsjs/api/classes/ReportDesigner.Designer) by binding a variable to the Designer node, for example:

```javascript
<script lang="ts">
    import {Designer} from "@mescius/activereportsjs-svelte";
    import {onMount} from 'svelte';
    let designerInst: Designer;
    onMount(()=>{
        designerInst.setReport({ id: "report.rdlx-json", displayName: "my report" });
    })
</script>

<div id="designer-host">
    <Designer bind:this={designerInst}></Designer>
</div>
```

# ActiveReportsJS React Report Designer

Learn how to use ActiveReportsJS React Report Designer

## Content

This page provides a detailed overview of the ActiveReportsJS React Report Designer. You can check the [Get Started](/activereportsjs/docs/v6.0/GettingStarted/QuickStart-ARJS-Designer-Component/QuickStart-React) tutorial for a concise guide for integrating the designer component into a React application.

### ActiveReportsJS React NPM package

We distribute the library that contains the ActiveReportsJS React Report Designer component via the [@mescius/activereportsjs-react](https://www.npmjs.com/package/@mescius/activereportsjs-react) npm package. The main [@mescius/activereportsjs](https://www.npmjs.com/package/@mescius/activereportsjs) package provides the core functionality.

### ActiveReportsJS React Designer component

ActiveReportsJS React Designer component can be imported to a JSX(TSX) file and included in a component's rendering tree, for example:

```javascript
import { Designer } from "@mescius/activereportsjs-react";
function App() {
  return (
    <div>
      <Designer />
    </div>
  );
}
```

The designer component accepts the following properties.

| Property | Type | Description |
| -------- | ---- | ----------- |
| onInit | ()=>[DesignerConfig](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#designerconfig) | returns the [DesignerConfig](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#designerconfig) object that contains the designer's initialization options |
| customInitTemplates |  | **Obsolete**: use the `onInit` callback instead. |
| hotkeysEnabled | boolean | **Obsolete**: use the `onInit` callback instead. |
| language | string | **Obsolete**: use the `onInit` callback instead. |
| fontSet | "default" \| "registered" \| "all" | **Obsolete**: use the `onInit` callback instead. |
| dataSources | array of [Data Source Templates](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#datasourcetemplate) | sets the [Pre-defined data sources and data sets](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Add-Predefined-Datasources-Datasets). |
| reportList | array of [Report Resource Info items](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#reportresourceinfo) | sets the [Pre-defined report names for a subreport](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Use-Shared-Resources) |
| imageList | array of [Image Resource Info items](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#imageresourceinfo) | sets the [Pre-defined images for an Image report item](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Use-Shared-Resources) |
| onCreate | [onCreate function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#oncreate) | adds the [New Report button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Create-New-Report#enabling-the-new-report-button) in the designer toolbar and sets the corresponding click handler |
| onOpen | [onOpen function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onopen) | adds the [Open Report](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Create-New-Report#enabling-the-open-report-button) button in the designer toolbar and sets the corresponding click handler |
| onRender | [onRender function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onrender) | adds the [Preview Report button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Preview-Reports) in the designer toolbar and sets the corresponding click handler |
| onSave | [onSave function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onsave) | adds the [Save Report button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Save-Reports) in the designer toolbar and sets the corresponding click handler |
| onSaveAs | [onSaveAs function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onsaveas) | adds the [Save As.. button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Save-Reports) in the designer toolbar and sets the corresponding click handler |
| onOpenFileMenu | [onOpenFileMenu function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onopenfilemenu) | adds the "File" menu in the designer toolbar and sets the corresponding click handler |
| report | [Report object](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#report) | loads the specified report in the designer |
| documentChanged | (args: DocumentChangedEventArgs)=>void | sets the handler for the event that occurs when a report loaded into the designer changes |

Also, the parent component can use the `getReport`, `setReport`, and `processCommand` methods of the [Designer class instance](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner) by creating the `ref` for a Designer component, for example

```javascript
import { Designer } from "@mescius/activereportsjs-react";
function App() {
  const designerRef = React.createRef();
  const btnClick = function () {
    designerRef.current.setReport({id: "report.rdlx-json"});
  };
  return (
    <div id="designer-host">
      <button type="button" onClick={btnClick}>
        Open Report
      </button>
      <Designer ref={designerRef} />
    </div>
  );
}
```

# ActiveReportsJS ActiveReportsJS Vue Report Designer

Learn how to use ActiveReportsJS Vue Report Designer

## Content

This page provides a detailed overview of the ActiveReportsJS Vue Report Designer. You can check the [Get Started](/activereportsjs/docs/v6.0/GettingStarted/QuickStart-ARJS-Designer-Component/QuickStart-Vue) tutorial for a concise guide for integrating the report designer into a Vue application.

### ActiveReportsJS Vue NPM package

We distribute the library that contains the ActiveReportsJS Vue Report Designer via the [@mescius/activereportsjs-vue](https://www.npmjs.com/package/@mescius/activereportsjs-vue) npm package. The main [@mescius/activereportsjs](https://www.npmjs.com/package/@mescius/activereportsjs) package provides the core functionality. 

### ActiveReportsJS Vue Designer component

ActiveReportsJS Vue Designer component can be imported from `@mescius/activereportsjs-vue` package and included in a parent component's template, for example:

```javascript
import Vue from "vue";
import { Designer } from "@mescius/activereportsjs-vue";

new Vue({
  el: "#app",
  components: { "arjs-designer": Designer },
  template: "<div style='width:100%;height: 100vh'><arjs-designer /></div>",
});
```

The designer component accepts the following properties.

| Property | Type | Description |
| -------- | ---- | ----------- |
| onInit | ()=>[DesignerConfig](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#designerconfig) | returns the [DesignerConfig](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#designerconfig) object that contains the designer's initialization options |
| hotkeysEnabled | boolean | **Obsolete**: use the `onInit` callback instead. |
| language | string | **Obsolete**: use the `onInit` callback instead. |
| customInitTemplates |  | **Obsolete**: use the `onInit` callback instead. |
| fontSet | "default" \| "registered" \| "all" | **Obsolete**: use the `onInit` callback instead. |
| dataSources | array of [Data Source Templates](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#datasourcetemplate) | sets the [Pre-defined data sources and data sets](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Add-Predefined-Datasources-Datasets). |
| reportList | array of [Report Resource Info items](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#reportresourceinfo) | sets the [Pre-defined report names for a subreport](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Use-Shared-Resources) |
| imageList | array of [Image Resource Info items](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#imageresourceinfo) | sets the [Pre-defined images for an Image report item](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Use-Shared-Resources) |
| onCreate | [onCreate function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#oncreate) | adds the [New Report button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Create-New-Report#enabling-the-new-report-button) in the designer toolbar and sets the corresponding click handler |
| onOpen | [onOpen function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onopen) | adds the [Open Report](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Create-New-Report#enabling-the-open-report-button) button in the designer toolbar and sets the corresponding click handler |
| onRender | [onRender function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onrender) | adds the [Preview Report button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Preview-Reports) in the designer toolbar and sets the corresponding click handler |
| onSave | [onSave function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onsave) | adds the [Save Report button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Save-Reports) in the designer toolbar and sets the corresponding click handler |
| onSaveAs | [onSaveAs function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onsaveas) | adds the [Save As.. button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Save-Reports) in the designer toolbar and sets the corresponding click handler |
| onOpenFileMenu | [onOpenFileMenu function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onopenfilemenu) | adds the "File" menu in the designer toolbar and sets the corresponding click handler |
| report | [Report object](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#report) | loads the specified report in the designer |
| documentChanged | (args: DocumentChangedEventArgs)=>void | sets the handler for the event that occurs when a report loaded into the designer changes |

In addition, the parent component can use the `getReport`, `setReport`, and `processCommand` methods of the [Designer class instance](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner) by creating the `ref` for a Designer component, for example

```javascript
import Vue from "vue";
import { Designer } from "@mescius/activereportsjs-vue";

new Vue({
  el: "#app",
  components: { "arjs-designer": Designer },
  template:
    "<div style='width:100%;height: 100vh'><arjs-designer ref='reportDesigner' /></div>",
  mounted: function () {
    this.$refs.reportDesigner.setReport({id: "report.rdlx-json"})
  },
});
```

# ActiveReportsJS Angular Report Designer

Learn how to use the ActiveReportsJS Angular Report Designer

## Content

This page provides a detailed overview of the ActiveReportsJS Angular Report Designer component. You can check the [Get Started](/activereportsjs/docs/v6.0/GettingStarted/QuickStart-ARJS-Designer-Component/QuickStart-Angular) tutorial for a concise guide for integrating the report designer component into an Angular application.

### ActiveReportsJS Angular NPM package

We distribute the library that contains ActiveReportsJS Angular Report Designer via the [@mescius/activereportsjs-angular](https://www.npmjs.com/package/@mescius/activereportsjs-angular) npm package. The main [@mescius/activereportsjs](https://www.npmjs.com/package/@mescius/activereportsjs) package provides the core functionality.

### ActiveReportsJS Angular Module

The ActiveReportsJS Angular Report Designer resides in the `ActiveReportsModule` Angular module, so it should be imported to the application's root module or other module that is intended to use the report designer, for example:

```javascript
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";
import { ActiveReportsModule } from "@mescius/activereportsjs-angular";

import { AppComponent } from "./app.component";

@NgModule({
  declarations: [AppComponent],
  imports: [BrowserModule, ActiveReportsModule],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}
```

### ActiveReportsJS Angular Designer Component

You can integrate the ActiveReportsJS Angular Report Designer component with the `gc-activereports-designer` tag. You can use the following input properties.

| Property | Type | Description |
| -------- | ---- | ----------- |
| onInit | ()=>[DesignerConfig](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#designerconfig) | returns the [DesignerConfig](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#designerconfig) object that contains the designer's initialization options |
| customInitTemplates |  | **Obsolete**: use the `onInit` callback instead. |
| hotkeysEnabled | boolean | **Obsolete**: use the `onInit` callback instead. |
| language | string | **Obsolete**: use the `onInit` callback instead. |
| fontSet | "default" \| "registered" \| "all" | **Obsolete**: use the `onInit` callback instead. |
| dataSources | array of [Data Source Templates](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#datasourcetemplate) | sets the [Pre-defined data sources and data sets](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Add-Predefined-Datasources-Datasets). |
| reportList | array of [Report Resource Info items](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#reportresourceinfo) | sets the [Pre-defined report names for a subreport](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Use-Shared-Resources) |
| imageList | array of [Image Resource Info items](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#imageresourceinfo) | sets the [Pre-defined images for an Image report item](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Use-Shared-Resources) |
| onCreate | [onCreate function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#oncreate) | adds the [New Report button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Create-New-Report#enabling-the-new-report-button) in the designer toolbar and sets the corresponding click handler |
| onOpen | [onOpen function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onopen) | adds the [Open Report](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Create-New-Report#enabling-the-open-report-button) button in the designer toolbar and sets the corresponding click handler |
| onRender | [onRender function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onrender) | adds the [Preview Report button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Preview-Reports) in the designer toolbar and sets the corresponding click handler |
| onSave | [onSave function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onsave) | adds the [Save Report button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Save-Reports) in the designer toolbar and sets the corresponding click handler |
| onSaveAs | [onSaveAs function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onsaveas) | adds the [Save As.. button](/activereportsjs/docs/v6.0/DeveloperGuide/ActiveReportsJSDesignerComponent/Save-Reports) in the designer toolbar and sets the corresponding click handler |
| onOpenFileMenu | [onOpenFileMenu function](https://developer.mescius.com/activereportsjs/api/interfaces/ReportDesigner.ActionHandlers#onopenfilemenu) | adds the "File" menu in the designer toolbar and sets the corresponding click handler |
| report | [Report object](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner#report) | loads the specified report in the designer |
| documentChanged | (args: DocumentChangedEventArgs)=>void | sets the handler for the event that occurs when a report loaded into the designer changes |

In addition, the parent component can use the `getReport`, `setReport`, and `processCommand` methods of the [Designer class instance](https://developer.mescius.com/activereportsjs/api/modules/ReportDesigner) with `ViewChild` injection.

```javascript
@ViewChild(DesignerComponent, { static: false }) reportDesigner: DesignerComponent;
```